diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/model/geographic-positions.h ns-3.42/src/mobility/model/geographic-positions.h
--- ns-3.41/src/mobility/model/geographic-positions.h	2024-02-09 14:44:08.365793500 -0800
+++ ns-3.42/src/mobility/model/geographic-positions.h	2024-05-29 15:29:47.136073600 -0700
@@ -45,6 +45,37 @@
      * Mapping Agency, 1 Jan. 2000.
      * <https://web.archive.org/web/20200729203634/https://earth-info.nga.mil/GandG/publications/tr8350.2/wgs84fin.pdf>.
      */
+
+    /// Earth's radius in meters if modeled as a perfect sphere
+    static constexpr double EARTH_SPHERE_RADIUS = 6371e3;
+
+    /// Earth's eccentricity if modeled as a perfect sphere
+    static constexpr double EARTH_SPHERE_ECCENTRICITY = 0;
+
+    /// Earth's flattening if modeled as a perfect sphere
+    static constexpr double EARTH_SPHERE_FLATTENING = 0;
+
+    /// <Earth's semi-major axis in meters as defined by both GRS80 and WGS84
+    /// https://en.wikipedia.org/wiki/World_Geodetic_System
+    static constexpr double EARTH_SEMIMAJOR_AXIS = 6378137;
+
+    /// Earth's first eccentricity as defined by GRS80
+    /// https://en.wikipedia.org/wiki/Geodetic_Reference_System_1980
+    static constexpr double EARTH_GRS80_ECCENTRICITY = 0.0818191910428158;
+
+    /// Earth's first flattening as defined by GRS80
+    /// https://en.wikipedia.org/wiki/Geodetic_Reference_System_1980
+    static constexpr double EARTH_GRS80_FLATTENING = 0.003352810681183637418;
+
+    /// Earth's first eccentricity as defined by
+    /// https://en.wikipedia.org/wiki/World_Geodetic_System#WGS84
+    static constexpr double EARTH_WGS84_ECCENTRICITY = 0.0818191908426215;
+
+    /// Earth's first flattening as defined by WGS84
+    /// https://en.wikipedia.org/wiki/World_Geodetic_System#WGS84
+    static constexpr double EARTH_WGS84_FLATTENING = 0.00335281;
+
+    /// The possible Earth spheroid models.  .
     enum EarthSpheroidType
     {
         SPHERE,
@@ -63,7 +94,7 @@
      * @param altitude height of the point (in meters) above earth's surface
      * @param sphType earth spheroid model to use for conversion
      *
-     * @return a vector containing the Cartesian coordinates (x, y, z referenced
+     * @return a vector representing the Cartesian coordinates (x, y, z referenced
      * in meters) of the point (origin (0, 0, 0) is center of earth)
      */
     static Vector GeographicToCartesianCoordinates(double latitude,
@@ -78,7 +109,7 @@
      * geographic coordinates. The residual delta is 1 m, which is approximately
      * 1 / 30 arc seconds or 9.26e-6 deg.
      *
-     * @param pos a vector containing the Cartesian coordinates (x, y, z referenced
+     * @param pos a vector representing the Cartesian coordinates (x, y, z referenced
      * in meters) of the point (origin (0, 0, 0) is center of earth)
      * @param sphType earth spheroid model to use for conversion
      *
@@ -92,6 +123,50 @@
     static Vector CartesianToGeographicCoordinates(Vector pos, EarthSpheroidType sphType);
 
     /**
+     * Conversion from geographic to topocentric coordinates.
+     *
+     * Conversion formulas taken from [1, Sec. 4.1.3 "Geographic/topocentric conversions"].
+     * [1] IOGP. Geomatics guidance note 7, part 2: coordinate conversions & transformations
+     * including formulas. IOGP Publication 373-7-2, International Association For Oil And Gas
+     * Producers, Sep. 2019
+     * https://www.iogp.org/bookstore/product/coordinate-conversions-and-transformation-including-formulas/
+     *
+     * @param pos a vector representing the Geographic coordinates (latitude, longitude, altitude)
+     * in degrees (lat/lon) and meters (altitude).
+     * @param refPoint a vector representing the reference point (latitude, longitude, altitude) in
+     * degrees (lat/lon) and meters (altitude). Default is (0,0,0)
+     * @param sphType earth spheroid model to use for conversion
+     *
+     * @return Vector position in meters and using planar Cartesian coordinates, i.e., ns-3's
+     * defaults
+     */
+    static Vector GeographicToTopocentricCoordinates(Vector pos,
+                                                     Vector refPoint,
+                                                     EarthSpheroidType sphType);
+
+    /**
+     * Conversion from topocentric to geographic.
+     *
+     * Conversion formulas taken from [1, Sec. 4.1.3 "Geographic/topocentric conversions"].
+     * [1] IOGP. Geomatics guidance note 7, part 2: coordinate conversions & transformations
+     * including formulas. IOGP Publication 373-7-2, International Association For Oil And Gas
+     * Producers, Sep. 2019
+     * https://www.iogp.org/bookstore/product/coordinate-conversions-and-transformation-including-formulas/
+     *
+     * @param pos a vector representing the topocentric coordinates (u, v, w) in meters, which
+     * represent the cartesian coordinates along the xEast, yNorth and zUp axes, respectively..
+     * @param refPoint a vector representing the reference point (latitude, longitude, altitude) in
+     * degrees (lat/lon) and meters (altitude). Default is (0,0,0)
+     * @param sphType earth spheroid model to use for conversion
+     *
+     * @return Vector position (latitude, longitude, altitude) in degrees (lat/lon) and meters
+     * (altitude) converted to geographic coordinates
+     */
+    static Vector TopocentricToGeographicCoordinates(Vector pos,
+                                                     Vector refPoint,
+                                                     EarthSpheroidType sphType);
+
+    /**
      * Generates uniformly distributed random points (in ECEF Cartesian
      * coordinates) within a given altitude above earth's surface centered around
      * a given origin point (on earth's surface, in geographic/geodetic coordinates)
@@ -123,6 +198,13 @@
         int numPoints,
         double maxDistFromOrigin,
         Ptr<UniformRandomVariable> uniRand);
+
+    /**
+     * @param type the type of model which is used to model the Earth
+     *
+     * @return the corresponding radius (in meters), first eccentricity and first flattening values
+     */
+    static std::tuple<double, double, double> GetRadiusEccentFlat(EarthSpheroidType type);
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/model/random-walk-2d-mobility-model.cc ns-3.42/src/mobility/model/random-walk-2d-mobility-model.cc
--- ns-3.41/src/mobility/model/random-walk-2d-mobility-model.cc	2024-02-09 14:44:08.365793500 -0800
+++ ns-3.42/src/mobility/model/random-walk-2d-mobility-model.cc	2024-05-29 15:29:47.136073600 -0700
@@ -94,45 +94,43 @@
     Vector position = m_helper.GetCurrentPosition();
 
     double speed = m_speed->GetValue();
-    double direction = 0;
-    if (!m_bounds.IsOnTheBorder(position))
+    double direction = m_direction->GetValue();
+    Vector velocity(std::cos(direction) * speed, std::sin(direction) * speed, 0.0);
+    if (m_bounds.IsOnTheBorder(position))
     {
-        direction = m_direction->GetValue();
-    }
-    else
-    {
-        Ptr<UniformRandomVariable> directionOverride = CreateObject<UniformRandomVariable>();
         switch (m_bounds.GetClosestSideOrCorner(position))
         {
         case Rectangle::RIGHTSIDE:
-            direction = directionOverride->GetValue(M_PI_2, M_PI + M_PI_2);
+            velocity.x = -1 * std::abs(velocity.x);
             break;
         case Rectangle::LEFTSIDE:
-            direction = directionOverride->GetValue(-M_PI_2, M_PI - M_PI_2);
+            velocity.x = std::abs(velocity.x);
             break;
         case Rectangle::TOPSIDE:
-            direction = directionOverride->GetValue(M_PI, 2 * M_PI);
+            velocity.y = -1 * std::abs(velocity.y);
             break;
         case Rectangle::BOTTOMSIDE:
-            direction = directionOverride->GetValue(0, M_PI);
+            velocity.y = std::abs(velocity.y);
             break;
         case Rectangle::TOPRIGHTCORNER:
-            direction = directionOverride->GetValue(M_PI, M_PI + M_PI_2);
+            velocity.x = -1 * std::abs(velocity.x);
+            velocity.y = -1 * std::abs(velocity.y);
             break;
         case Rectangle::TOPLEFTCORNER:
-            direction = directionOverride->GetValue(M_PI + M_PI_2, 2 * M_PI);
+            velocity.x = std::abs(velocity.x);
+            velocity.y = -1 * std::abs(velocity.y);
             break;
         case Rectangle::BOTTOMRIGHTCORNER:
-            direction = directionOverride->GetValue(0, M_PI_2);
-            direction += M_PI / 2;
+            velocity.x = -1 * std::abs(velocity.x);
+            velocity.y = std::abs(velocity.y);
             break;
         case Rectangle::BOTTOMLEFTCORNER:
-            direction = directionOverride->GetValue(M_PI_2, M_PI);
+            velocity.x = std::abs(velocity.x);
+            velocity.y = std::abs(velocity.y);
             break;
         }
     }
-    Vector vector(std::cos(direction) * speed, std::sin(direction) * speed, 0.0);
-    m_helper.SetVelocity(vector);
+    m_helper.SetVelocity(velocity);
     m_helper.Unpause();
 
     Time delayLeft;
@@ -151,10 +149,10 @@
 RandomWalk2dMobilityModel::DoWalk(Time delayLeft)
 {
     Vector position = m_helper.GetCurrentPosition();
-    Vector speed = m_helper.GetVelocity();
+    Vector velocity = m_helper.GetVelocity();
     Vector nextPosition = position;
-    nextPosition.x += speed.x * delayLeft.GetSeconds();
-    nextPosition.y += speed.y * delayLeft.GetSeconds();
+    nextPosition.x += velocity.x * delayLeft.GetSeconds();
+    nextPosition.y += velocity.y * delayLeft.GetSeconds();
     m_event.Cancel();
     if (m_bounds.IsInside(nextPosition))
     {
@@ -163,17 +161,17 @@
     }
     else
     {
-        nextPosition = m_bounds.CalculateIntersection(position, speed);
+        nextPosition = m_bounds.CalculateIntersection(position, velocity);
         double delaySeconds = std::numeric_limits<double>::max();
-        if (speed.x != 0)
+        if (velocity.x != 0)
         {
             delaySeconds =
-                std::min(delaySeconds, std::abs((nextPosition.x - position.x) / speed.x));
+                std::min(delaySeconds, std::abs((nextPosition.x - position.x) / velocity.x));
         }
-        else if (speed.y != 0)
+        else if (velocity.y != 0)
         {
             delaySeconds =
-                std::min(delaySeconds, std::abs((nextPosition.y - position.y) / speed.y));
+                std::min(delaySeconds, std::abs((nextPosition.y - position.y) / velocity.y));
         }
         else
         {
@@ -194,27 +192,26 @@
 {
     m_helper.UpdateWithBounds(m_bounds);
     Vector position = m_helper.GetCurrentPosition();
-    Vector speed = m_helper.GetVelocity();
+    Vector velocity = m_helper.GetVelocity();
     switch (m_bounds.GetClosestSideOrCorner(position))
     {
     case Rectangle::RIGHTSIDE:
     case Rectangle::LEFTSIDE:
-        speed.x = -speed.x;
+        velocity.x = -velocity.x;
         break;
     case Rectangle::TOPSIDE:
     case Rectangle::BOTTOMSIDE:
-        speed.y = -speed.y;
+        velocity.y = -velocity.y;
         break;
     case Rectangle::TOPRIGHTCORNER:
     case Rectangle::BOTTOMRIGHTCORNER:
     case Rectangle::TOPLEFTCORNER:
     case Rectangle::BOTTOMLEFTCORNER:
-        auto temp = speed.x;
-        speed.x = -speed.y;
-        speed.y = -temp;
+        velocity.x = -velocity.x;
+        velocity.y = -velocity.y;
         break;
     }
-    m_helper.SetVelocity(speed);
+    m_helper.SetVelocity(velocity);
     m_helper.Unpause();
     DoWalk(delayLeft);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/model/random-waypoint-mobility-model.cc ns-3.42/src/mobility/model/random-waypoint-mobility-model.cc
--- ns-3.41/src/mobility/model/random-waypoint-mobility-model.cc	2024-02-09 14:44:08.365793500 -0800
+++ ns-3.42/src/mobility/model/random-waypoint-mobility-model.cc	2024-05-29 15:29:47.136073600 -0700
@@ -66,15 +66,19 @@
     Vector m_current = m_helper.GetCurrentPosition();
     NS_ASSERT_MSG(m_position, "No position allocator added before using this model");
     Vector destination = m_position->GetNext();
+    Vector delta = destination - m_current;
+    double distance = delta.GetLength();
     double speed = m_speed->GetValue();
-    double dx = (destination.x - m_current.x);
-    double dy = (destination.y - m_current.y);
-    double dz = (destination.z - m_current.z);
-    double k = speed / std::sqrt(dx * dx + dy * dy + dz * dz);
 
-    m_helper.SetVelocity(Vector(k * dx, k * dy, k * dz));
+    NS_ASSERT_MSG(speed > 0, "Speed must be strictly positive.");
+
+    // Note: the following two lines are needed to prevent corner cases where
+    // the distance is null (and the Velocity is undefined).
+    double k = distance ? speed / distance : 0;
+    Time travelDelay = distance ? Seconds(distance / speed) : Time(0);
+
+    m_helper.SetVelocity(k * delta);
     m_helper.Unpause();
-    Time travelDelay = Seconds(CalculateDistance(destination, m_current) / speed);
     m_event.Cancel();
     m_event =
         Simulator::Schedule(travelDelay, &RandomWaypointMobilityModel::DoInitializePrivate, this);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/model/steady-state-random-waypoint-mobility-model.cc ns-3.42/src/mobility/model/steady-state-random-waypoint-mobility-model.cc
--- ns-3.41/src/mobility/model/steady-state-random-waypoint-mobility-model.cc	2024-02-09 14:44:08.365793500 -0800
+++ ns-3.42/src/mobility/model/steady-state-random-waypoint-mobility-model.cc	2024-05-29 15:29:47.136073600 -0700
@@ -183,7 +183,7 @@
         {
             pause = Seconds(u * expectedPauseTime);
         }
-        NS_ASSERT(!m_event.IsRunning());
+        NS_ASSERT(!m_event.IsPending());
         m_event =
             Simulator::Schedule(pause, &SteadyStateRandomWaypointMobilityModel::BeginWalk, this);
     }
@@ -209,7 +209,7 @@
         double u2 = m_u_r->GetValue(0, 1);
         m_helper.SetPosition(
             Vector(m_minX + u2 * x1 + (1 - u2) * x2, m_minY + u2 * y1 + (1 - u2) * y2, m_z));
-        NS_ASSERT(!m_event.IsRunning());
+        NS_ASSERT(!m_event.IsPending());
         m_event =
             Simulator::ScheduleNow(&SteadyStateRandomWaypointMobilityModel::SteadyStateBeginWalk,
                                    this,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/test/box-line-intersection-test.cc ns-3.42/src/mobility/test/box-line-intersection-test.cc
--- ns-3.41/src/mobility/test/box-line-intersection-test.cc	2024-02-09 14:44:08.365793500 -0800
+++ ns-3.42/src/mobility/test/box-line-intersection-test.cc	2024-05-29 15:29:47.136073600 -0700
@@ -31,7 +31,7 @@
  */
 
 BoxLineIntersectionTestSuite::BoxLineIntersectionTestSuite()
-    : TestSuite("box-line-intersection", UNIT)
+    : TestSuite("box-line-intersection", Type::UNIT)
 {
     // Box in the positive x-plane to check the intersection with.
     Box box = Box(890.0, 990.0, 840.0, 870.0, 0.0, 6.0);
@@ -42,28 +42,28 @@
     // Expected result: No intersection. The box is between the two position,
     // however, pos2 is above the height of the box.
     intersect = false;
-    AddTestCase(new BoxLineIntersectionTestCase(3, 6, box, intersect), TestCase::QUICK);
+    AddTestCase(new BoxLineIntersectionTestCase(3, 6, box, intersect), TestCase::Duration::QUICK);
 
     // Test #2 :
     // pos1 (index 1) is inside the box.
     // pos2 (index 2) is inside the box.
     // Expected result: Intersection.
     intersect = true;
-    AddTestCase(new BoxLineIntersectionTestCase(1, 2, box, intersect), TestCase::QUICK);
+    AddTestCase(new BoxLineIntersectionTestCase(1, 2, box, intersect), TestCase::Duration::QUICK);
 
     // Test #3 :
     // pos1 (index 3) is outside the box.
     // pos2 (index 1) is inside the box.
     // Expected result: Intersection.
     intersect = true;
-    AddTestCase(new BoxLineIntersectionTestCase(3, 1, box, intersect), TestCase::QUICK);
+    AddTestCase(new BoxLineIntersectionTestCase(3, 1, box, intersect), TestCase::Duration::QUICK);
 
     // Test #4:
     // pos1 (index 4) is outside the box.
     // pos2 (index 5) is outside the box.
     // Expected result: Intersection because box is in between the two positions.
     intersect = true;
-    AddTestCase(new BoxLineIntersectionTestCase(4, 5, box, intersect), TestCase::QUICK);
+    AddTestCase(new BoxLineIntersectionTestCase(4, 5, box, intersect), TestCase::Duration::QUICK);
 }
 
 static BoxLineIntersectionTestSuite boxLineIntersectionTestSuite; //!< boxLineIntersectionTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/test/gen-geocentric-topocentric-conversion-test-reference-points.sh ns-3.42/src/mobility/test/gen-geocentric-topocentric-conversion-test-reference-points.sh
--- ns-3.41/src/mobility/test/gen-geocentric-topocentric-conversion-test-reference-points.sh	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/mobility/test/gen-geocentric-topocentric-conversion-test-reference-points.sh	2024-05-29 15:29:47.136073600 -0700
@@ -0,0 +1,48 @@
+#!/bin/bash
+# Generate test coordinates and reference conversion coordinates for the
+# GeocentricTopocentricConversionTest.
+# This script requires PROJ binaries, wchih can be installed by following
+# the official instructions:
+# https://proj.org/en/9.4/install.html#install
+
+# Configure printf to use dot-separated integer and decimal parts
+export LC_NUMERIC="en_US.UTF-8"
+# Coordinates to convert (long (degree), lat (degree), alt (meters)
+long_vec=(2.1295495 0.0 30.0 60.0 90.0 120.0 150.0 180.0)
+lat_vec=(53.809394 0.0 20.0 40.0 60.0 80.0)
+alt_vec=(73.0 500.0 1000.0)
+# Reference coordinates (long (degree), lat (degree), alt (meters).
+# In particular, the following ones are used as an example in
+# Sec. 4.1.3, "IOGP Publication 373-7-2 – Geomatics Guidance Note number 7, part
+#  2 – September 2019".
+LONG_0=5
+LAT_0=55
+ALT_0=200
+# Reference elipsoids
+ellps_vec=(sphere GRS80 WGS84)
+# Convert geocentric -> topocentric coordinates
+# This conversion corresponds to EPSG Dataset coordinate operation
+# method code 9837, see "IOGP Publication 373-7-2 – Geomatics Guidance Note number 7, part
+# 2 – September 2019".
+for ellps in ${ellps_vec[@]}; do
+  echo $ellps
+  proj_out=""
+  test_coord=""
+  for long in ${long_vec[@]}; do
+    for lat in ${lat_vec[@]}; do
+      for alt in ${alt_vec[@]}; do
+        # Coordinates conversion using PROJ
+        proj_coord=$(echo $long $lat $alt | cct -d 3 +proj=pipeline +ellps=$ellps +step +proj=cart +step +proj=topocentric +lon_0=$LONG_0 +lat_0=$LAT_0 +h_0=$ALT_0)
+        # Update test coordinates string
+        test_coord="$test_coord""$(printf "{%f, %f, %f}, " $lat $long $alt)"
+        # Update reference conversion coordinates string
+        proj_out="$proj_out""$(echo $proj_coord | awk '{print "{" $1 "," $2 "," $3 "},"}')"
+      done
+    done
+  done
+  # Output test coordinates and reference conversion coordinates as C++ vector of vectors
+  echo "test coordinates"
+  echo $test_coord
+  echo "converted points"
+  echo $proj_out
+done
